; Initialize the sprite and keyboard systems and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(640,480,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

; include our generic library
XIncludeFile "../libraries/generic.pb"

ClearColor = RGB(0,0,0) 

; open the file for reading
FilePtr = CreateFile(#PB_Any,"filetest.bin")

If FilePtr = 0
   MessageRequester("Error!", "Unable to Create File", #PB_MessageRequester_Ok)
   End
EndIf 

; create a couple of buffer for the Write/Read Data commands
*MemoryBuffer1 = AllocateMemory(15)
*MemoryBuffer2 = AllocateMemory(15)
PokeS(*MemoryBuffer1,"Five Thousand!")

; write out our data
WriteByte(FilePtr,50)
WriteWord(FilePtr,500)
WriteLong(FilePtr,5000)
WriteFloat(FilePtr,5000.5)
WriteData(FilePtr,*MemoryBuffer1,15)

; close the file
CloseFile(FilePtr)

; show the reads
If StartDrawing(ScreenOutput()) 
  DrawText(0,0,"File created!")
  DrawText(0,400,"Press any key to read the data...")
Else
   MessageRequester("Error!", "Unable to Draw to ScreenOutput()", #PB_MessageRequester_Ok)
   End
EndIf

StopDrawing()

; show the output to the users
FlipBuffers()

; wait for a keypress
WaitKey()

ClearScreen(ClearColor)

; open the file for reading
FilePtr = OpenFile(#PB_Any,"filetest.bin")

If FilePtr = 0
   MessageRequester("Error!", "Unable to Read File", #PB_MessageRequester_Ok)
   End
EndIf 

; read in the binary data from the test file
value1.b = ReadByte(FilePtr)
value2.w = ReadWord(FilePtr)
value3.l = ReadLong(FilePtr)
value4.f = ReadFloat(FilePtr)
ReadData(FilePtr,*MemoryBuffer2,15)
value5.s = PeekS(*MemoryBuffer2,15)

; close the file
CloseFile(FilePtr)

; show the altered reads
If StartDrawing(ScreenOutput()) 
  DrawText(0,0,"Byte: " + Str(value1))
  DrawText(0,16,"Word: " + Str(value2))
  DrawText(0,32,"Long: " + Str(value3))
  DrawText(0,48,"Float: " + Str(value4.f))
  DrawText(0,64,"Data: " + value5)
  DrawText(0,400,"Press any key to exit")
Else
   MessageRequester("Error!", "Unable to Draw to ScreenOutput()", #PB_MessageRequester_Ok)
   End
EndIf

StopDrawing()

; show the output to the users
FlipBuffers()

; wait for a keypress
WaitKey ()

; end the program
End

; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 70
; FirstLine = 57