; Initialize the sprite and keyboard systems and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitSprite3D() = 0 Or InitKeyboard() = 0 Or OpenScreen(640,480,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

ClearColor = RGB(0,0,0) 

; Make it use 10-deg points, change this number around to see differences,
; but be sure it's equally divisible into 360 or you may see blowups.
; Try 10, 36, 72, 180, 360
Rotations = 36

; setup an array to hold our ship images
Global Dim Migz(Rotations)

; declard our graphics procedure
Declare Rotate_2D_To_Array(ImageToUse,Rotations)

; Use the PNG decoder for image loads.
UsePNGImageDecoder()

; load in the sprite with 3D capability
SpriteID = LoadSprite(#PB_Any,"migz.png",#PB_Sprite_Texture)

; set the appropriate mask so we have transparencies
TransparentSpriteColor(SpriteID,RGB(255,0,255))

; call the library procedure that rotates and copies the images
Rotate_2D_To_Array(SpriteID,Rotations)

; setup a little var for rotations
CurrentAngle = 0

Repeat
   ; clear the screen
   ClearScreen(ClearColor)
   
   ; just show our sprites spinning
   For y = 0 To 10
       For X = 0 To 14
           DisplayTransparentSprite(Migz(CurrentAngle), X * SpriteWidth(SpriteID), Y * SpriteHeight(SpriteID))
       Next
   Next

   ; simple tracking of the array position for visual effect
   CurrentAngle = CurrentAngle + 1
   If CurrentAngle >= Rotations
      CurrentAngle = 0
   EndIf     
   
   StartDrawing(ScreenOutput())
     DrawText(0,460,"Press any key To quit")
   StopDrawing()

   FlipBuffers()
   
   ExamineKeyboard()
Until KeyboardReleased(#PB_Any)

End


;****************************************************
; Various graphics/sprite procedures
;****************************************************

;****************************************************
;  Procedure: Rotate_2D_To_Array(...)
;     Author: John Logsdon
;   Last Upd: 9/02/2012
;    Purpose: Rotates a 2D image and places their
;             respective handles into an array
;       Args: The image to use, the # of rotations
;    Returns: n/a - but does fill the array
;   Comments: I grab from -5,-5 to +5, +5 of the 3D 
;             image because when an image is rotated, 
;             it changes size accordingly.I know there 
;             are mathematical ways to properly adjust 
;             for this, but I'm just using a 
;             quick-n-dirty method here.  
 ;****************************************************
Procedure Rotate_2D_To_Array(ImageToUse,Rotations)
   ; find the actual rotation amount
   ; i.e.: 360/36 = 10.  So 10-degrees is the rotation distance
   RotationAmount = 360 / Rotations
   ; start our initial angle at 0
   Angle = 0
   
   ; where to display the object for grabbing
   DisplayX = 50
   DisplayY = 50
   
   ; get the width and height plus some buffering so we don't have
   ; to call it every iteration of the loop
   Width=SpriteWidth(ImageToUse) + 10
   Height=SpriteHeight(ImageToUse) + 10
   
   ; Create a 3D sprite
   Sprite3D_ID = CreateSprite3D(#PB_Any,ImageToUse)
  
   ; since we're only going to use this to rotate and place in 2D pieces, set the quality up
   Sprite3DQuality(1)
   
   ; run through the rotations
   For i = 0 To Rotations - 1
       ; Set a number in our Migz array
       Migz(i) = i
       
       ClearScreen(ClearColor)
       
       ; start up the 3D drawing piece
       Start3D()
          ; rotate the sprite, but then leave back to it's original position
          ; for next call
          RotateSprite3D(Sprite3D_ID,Angle,#PB_Relative)
          ; draw the sprite using 3D
          DisplaySprite3D(Sprite3D_ID,DisplayX,DisplayY)
       Stop3D()
       ; grab the sprite to 2D
       GrabSprite(Migz(i),DisplayX - 5,DisplayY - 5,Width,Height,0)
       ; Update the angle
       Angle = Angle + RotationAmount 
   Next
EndProcedure
; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 108
; FirstLine = 86
; Folding = -