; setup our Screen Width and Height here for easier tracking
#ScreenWidth  = 640
#ScreenHeight = 480

; Initialize the sprite and keyboard, mouse, and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or InitMouse() = 0 Or OpenScreen(#ScreenWidth,#ScreenHeight,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

ClearColor = RGB(0,0,0) 

LastClicked.s = "None"
HeldDown.s = "None"

; load in the sprite
LoadSprite(0,"mouse.bmp")

MouseLocate(320,240)
 
; Keep going until the user hits a key
Repeat
   ; clear the screen
   ClearScreen(ClearColor)

   If ExamineMouse()
      X = MouseX()
      Y = MouseY()
      X_Movement = MouseDeltaX()
      If X_Movement < 0
         X_MouseMovement.s = "Left"
      ElseIf X_Movement > 0
         X_MouseMovement.s = "Right"
      Else
         X_MouseMovement.s = ""
      EndIf

      Y_Movement = MouseDeltaY()
      If Y_Movement < 0
         Y_MouseMovement.s = "Up"
      ElseIf Y_Movement > 0
         Y_MouseMovement.s = "Down"
      Else
         Y_MouseMovement.s = ""
      EndIf

      Wheel_Movement = MouseWheel()
      If Wheel_Movement < 0
         Wheel_MouseMovement.s = "Down"
      ElseIf Wheel_Movement > 0
         Wheel_MouseMovement.s = "Up"
      Else
         Wheel_MouseMovement.s = ""
      EndIf
      MB_Data.s = ""
      For MButton = 1 To 3
          If MouseButton(MButton)
             If MB_Data.s = ""
                MB_Data.s = Str(MButton)
             Else
                MB_Data.s = MB_Data.s + ", " + Str(MButton)
             EndIf
          EndIf
      Next
   EndIf
   
   ; show our mouse
   DisplaySprite(0,X,Y)

   ; put up text for information
   StartDrawing(ScreenOutput())
     DrawText(0,0,"Current Mouse Position: " + Str(X) + "," + Str(Y))
     DrawText(0,20,"X Movement = " + X_MouseMovement.s + ", Distance = " + Str(X_Movement))
     DrawText(0,40,"Y Movement = " + Y_MouseMovement.s + ", Distance = " + Str(Y_Movement))
     DrawText(0,60,"Wheel Movement = " + Wheel_MouseMovement.s + ", Distance = " + Str(Wheel_Movement))
     DrawText(0,80,"Buttons Pressed = " + MB_Data.s )
     DrawText(0,460,"Press any key To quit")
   StopDrawing()

   FlipBuffers()

   ExamineKeyboard()
Until KeyboardReleased(#PB_Key_All)

End





; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 71
; FirstLine = 51