; Initialize the sprite and keyboard systems and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(640,480,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

; Allocate 2 bytes of memory, WORD VALUE
*MemoryID = AllocateMemory(2)

If *MemoryID = 0
   MessageRequester("Error!", "Unable to Allocate Memory", #PB_MessageRequester_Ok)
   End
EndIf

; store our value, using Poke
PokeW(*MemoryID,12123)

; Read back our value, using Peek
Value.w = PeekW(*MemoryID)

StartDrawing(ScreenOutput())

    ; Show the user the value
    DrawText(0,0,"The value in our memory buffer is: " + Str(Value))
    
     ; display a message so the user knows how to exit     
    DrawText(0,400,"Press any key to continue")

StopDrawing()
 
FlipBuffers()  ; show the output to the user

; wait for any key to be pressed
Repeat 
   ExamineKeyboard()
Until KeyboardReleased(#PB_Key_All)


; Let's reallocate the memory to be a Long
ReAllocateMemory(*MemoryID,4)

If *MemoryID = 0
   MessageRequester("Error!", "Unable to ReAllocate Memory", #PB_MessageRequester_Ok)
   End
EndIf

; store our value, using Poke - now a long
PokeL(*MemoryID,50000)
; Read back our value, using Peek
Value2.l = PeekL(*MemoryID)

StartDrawing(ScreenOutput())

    ; Show the user the value
    DrawText(0,0,"The new value in our memory buffer is: " + Str(Value2))
    
     ; display a message so the user knows how to exit     
    DrawText(0,400,"Press any key to continue")

StopDrawing()
 
FlipBuffers()  ; show the output to the user

; wait for any key to be pressed
Repeat 
   ExamineKeyboard()
Until KeyboardReleased(#PB_Key_All)

; free the allocated memory 
FreeMemory(*MemoryID)

End  ; end the program

; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 57
; FirstLine = 34