FASM Tutorials
==============

This sections gathers tutorials for FASM (flat assembler).

<!-- #toc -->
-   [Tutorial Files](#tutorial-files)
    -   [TAJGA FASM Tutorial](#tajga-fasm-tutorial)
    -   [TAJGA FASM Tutorial, CHM Version](#tajga-fasm-tutorial-chm-version)
    -   [FASM Preprocessor Guide](#fasm-preprocessor-guide)
-   [Tutorials MD-Source Files](#tutorials-md-source-files)

<!-- /toc -->
Tutorial Files
==============

-   [`tajga-fasm-tutorial.html`](./tajga-fasm-tutorial.html) — *TAJGA FASM Tutorial*, by **Vid** (2004). A beginners’ FASM tutorial for MS DOS.
-   [`fasm-preprocessor-guide.html`](fasm-preprocessor-guide.html) — *FASM Preprocessor Guide*, by **Vid** (2004). An introductory tutorial to FASM’s powerful preprocessor.
-   [`TAJGA-FASM-Tutorial.chm`](./TAJGA-FASM-Tutorial.chm) — **Vid**’s *TAJGA FASM Tutorial* and *FASM Preprocessor Guide* converted in CHM format.

TAJGA FASM Tutorial
-------------------

-   [`tajga-fasm-tutorial.html`](./tajga-fasm-tutorial.html)
-   [Tutorial HTML Live Preview](https://cdn.rawgit.com/tajmone/purebasic-archives/1351562/asm/fasm/tutorials/tajga-fasm-tutorial.html) (via rawgit.com)

*TAJGA FASM Tutorial*, written by **vid** (2004) of the **TAJGA Team**. License: Unrestricted. Downloaded from [asmhackers.net](http://asmhackers.net/) ([BOS subdomain](http://bos.asmhackers.net/)).

This is a FASM tutorial for beginners, no programming knowledge required. It’s written for MS DOS, so you will need a DOS emulator to actually try out the code examples.

-   [TAJGA FASM Tutorial — asmhackers.net](http://bos.asmhackers.net/docs/FASM%20tutorial/)
-   [TAJGA FASM Tutorial — thread on flatassembler.net](https://board.flatassembler.net/topic.php?t=1178)
-   [TAJGA FASM Tutorial — decard.net](https://web.archive.org/web/20060925090450/http://www.decard.net/article.php?body=tajga) (WaybackMachine)

TAJGA FASM Tutorial, CHM Version
--------------------------------

-   [`TAJGA-FASM-Tutorial.chm`](./TAJGA-FASM-Tutorial.chm)

**Vid**’s *TAJGA FASM Tutorial* and *FASM Preprocessor Guide* converted in CHM format by Nikolay Petrov (2005-04-01). Downloaded from [flatassembler.net](https://board.flatassembler.net/)’s message board:

-   [Announcement post on flatassembler.net](https://board.flatassembler.net/topic.php?t=1178&postdays=0&postorder=asc&start=43)

FASM Preprocessor Guide
-----------------------

-   [`fasm-preprocessor-guide.html`](fasm-preprocessor-guide.html)
-   [Tutorial HTML Live Preview](https://cdn.rawgit.com/tajmone/purebasic-archives/1351562/asm/fasm/tutorials/fasm-preprocessor-guide.html) (via rawgit.com)

*FASM Preprocessor Guide*, written by **vid** (2004) of the **TAJGA Team**. License: Unrestricted (also confirmed by the author via private messages exchange). Downloaded from [asmhackers.net](http://asmhackers.net/) ([BOS subdomain](http://bos.asmhackers.net/)).

This is a, introductory tutorial to FASM’s preprocessor.

-   [FASM Preprocessor Guide — asmhackers.net](http://bos.asmhackers.net/docs/FASM%20tutorial/preproc.html)
-   [FASM Preprocessor Guide — thread on flatassembler.net](https://board.flatassembler.net/topic.php?t=1178)

Tutorials MD-Source Files
=========================

-   [`/md-src/`](./md-src/)

Some tutorials are converted from multiple Markdown files into a single HTML5 document. Their source files are kept in the `/md-src/` subfolder to avoid cluttering the main folder.
