PureBASIC 3rd Party Libraries
=============================

Libraries (dynamic and static), modules, bindings, wrappers, SDKs, and all kind of third party resources that extend PureBASIC functionality…

For each resource we’ll try to include the PureBASIC version with/for which it was created; this should serve as indicator of compatiblity with current version of PB. Resources might have been updated since their inclusion in this list, follow the links to check for latest version.

Outdated resources (ie: for PureBASIC 4) are kept in the list when no up-to-date alternative is available — in case someone might be willing to update them to current PB version.

> **HELP US**: You noticed some missing resource here? Help the PureBASIC Archives grow by adding links and reviews to this file!

------------------------------------------------------------------------

<!-- #toc -->

- [In This Repo](#in-this-repo)
    - [Windows Registry Module](#windows-registry-module)
- [By Category](#by-category)
    - [Graphics](#graphics)
    - [GUI](#gui)
    - [HTML/CSS](#htmlcss)
    - [Multimedia](#multimedia)
        - [Audio](#audio)
    - [Network](#network)
    - [System](#system)
- [Commercial](#commercial)
    - [Chilkat](#chilkat)

<!-- /toc -->

------------------------------------------------------------------------

In This Repo
============

PureBASIC libs hosted inside the repository.

Windows Registry Module
-----------------------

-   [`/win-registry/`](./win-registry/) (Windows only)

by Thomas Schulz «**ts-soft**». Adds procedures for handling Windows’ registry read/write and delete operations. Unrestriced free license. (tested on **PB 5.5x**)

------------------------------------------------------------------------

By Category
===========

A list of libs — both from this repo and external linked-resources — sorted by category.

Graphics
--------

-   [PureSVG](http://forum.purebasic.com/english/viewtopic.php?f=12&t=40540&hilit=svg&sid=d87053584f2e9f23933eb991e680d7f8) – by Seymour Clufley. (**PB 5.22**). This “library” enables you to draw SVG images using analogues of 2D Drawing’s commands.

## GUI

- [TimerMsgBox](http://www.purebasic.fr/english/viewtopic.php?f=12&t=52145) — by TI-994A. A self-contained procedure to create multi-line, multi-button, timer-enabled, stay-on-top message boxes.

HTML/CSS
--------

-   [RWLibTidy](http://www.purearea.net/pb/english/dll_devtools.htm) — by Progi1984. (**!!PB 4!!**) Wrapper for the 2008/01/25 release of the [LibTidy](http://www.html-tidy.org/developer/) DLL, a library for cleaning up your HTML web pages.


Multimedia
----------

### Audio

-   [FMOD](http://00laboratories.com/resources/code/purebasic/fmod-header) – by 00laboratories. (**PB 5.41**). PB header file to import [FMOD](http://www.fmod.org/) sound library.
-   [FreeSL Wrapper](http://erion.tdrealms.com/software/fslwrapper) — by Erion. (**PB 5.21**). A wrapper for the FreeSL audio library, for OpenAL, ALUt and EAX2.0. Amongst playing things in 3d, you can add EAX effects to your sounds, load or stream audio normally and from zip files, and much more. Includes required DLLs, and code examples.
-   [Libsndfile](http://00laboratories.com/resources/code/purebasic/libsndfile-header) – by 00laboratories. (**PB 5.41**). PB header file for [Libsndfile](http://www.mega-nerd.com/libsndfile/) 1.0.25, a C library for importing/exporting various sound file formats.
-   [LibZPlay](http://erion.tdrealms.com/software/libzplay) — by Erion. (**PB 5.11**). A wrapper for the [LibZPlay](http://libzplay.sourceforge.net/) multimedia engine. Originally [ported to PB by TS-Soft](http://www.purebasic.fr/english/viewtopic.php?f=27&t=49345&hilit=LibZPlay), this version was [updated by Erion](http://www.purebasic.fr/english/viewtopic.php?f=12&t=54060&hilit=LibZPlay) to include some new functions from 2.0. Includes DLL, import lib file, the library’s original documentation in chm and a small PB example.
-   [OpenAL Soft](http://00laboratories.com/resources/code/purebasic/openal-soft-header) – by 00laboratories. (**PB 5.41**). PB header file to import [OpenAL Soft](http://www.openal-soft.org/) (Open Audio Library) sound engine.
-   [PurESpeak](http://erion.tdrealms.com/software/pb/purespeak) — by Erion (**PB 5.11**). A wrapper for [ESpeak](http://espeak.sourceforge.net/) standalone speech synthesizer. Includes a DLL version of ESpeak with voices and variants that is part of [NVDA](http://www.nvaccess.org/) (NonVisual Desktop Access).
-   [TagLib](http://erion.tdrealms.com/taglib) – by Erion (**PB 5.11**). A wrapper for the C bindings of [TagLib Audio Meta-Data Library](http://taglib.org/), which allows to read and write tags and audio properties.


Network
-------

-   [RWLibCurl](http://www.purearea.net/pb/english/dll_devtools.htm) — by Progi1984. (**!!PB 4!!**) Wrapper for the v7.17.1 of the [LibCurl](https://curl.haxx.se/libcurl/) DLL.

System
------

-   [Windows Registry Module](#windows-registry-module) (**in this repo**) — by **ts-soft**. Adds procedures for handling Windows’ registry read/write and delete operations.

Commercial
==========

Chilkat
-------

Chilkat Software Inc. offers a wide variety of components and libraries — email and network protocols, compression, encryption, digital signing, and others — that extend PureBASIC’s native power in the realm of network protocols and communications standards, offering full control over advanced functionalities. Chilkat products come in bundles, addressing specific areas of interest.

-   [Chilkat PureBasic Reference Documentation](https://www.chilkatsoft.com/refdoc/purebasic.asp)
-   [Chilkat PureBasic Examples](https://www.example-code.com/purebasic/default.asp)

